
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "glcd_test.vec"
	.INCLUDE "glcd_test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.8 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 5/4/2008
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 8.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include<delay.h>
;      37 #include <ks0108.h>

	.CSEG
_write_right:
;	x -> Y+0
	CBI  0x15,3
	SBI  0x15,4
	RCALL SUBOPT_0x0
	RJMP _0x5D
_write_left:
;	x -> Y+0
	SBI  0x15,3
	CBI  0x15,4
	RCALL SUBOPT_0x0
_0x5D:
	ADIW R28,1
	RET
_address_right:
;	x -> Y+2
;	y -> Y+0
	CBI  0x15,0
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _write_right
	LD   R30,Y
	ST   -Y,R30
	RCALL _write_right
	RJMP _0x5C
_address_left:
;	x -> Y+2
;	y -> Y+0
	CBI  0x15,0
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _write_left
	LD   R30,Y
	ST   -Y,R30
	RCALL _write_left
	RJMP _0x5C
_glcd_Init:
	SBIW R28,8
	LDI  R24,8
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x1F*2)
	LDI  R31,HIGH(_0x1F*2)
	CALL __INITLOCB
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
;	com -> Y+2
	LDI  R16,0
	LDI  R17,0
	CBI  0x15,0
_0x22:
	__CPWRN 16,17,4
	BRGE _0x24
	RCALL SUBOPT_0x1
	RCALL _write_left
	__ADDWRN 16,17,1
	RJMP _0x22
_0x24:
	__GETWRN 16,17,0
_0x25:
	__CPWRN 16,17,4
	BRGE _0x27
	RCALL SUBOPT_0x1
	RCALL _write_right
	__ADDWRN 16,17,1
	RJMP _0x25
_0x27:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,10
	RET
_glcd_WriteByte:
;	x -> Y+2
;	y -> Y+1
;	data -> Y+0
	LDD  R26,Y+1
	CPI  R26,LOW(0x40)
	BRSH _0x28
	RCALL SUBOPT_0x2
	RCALL _address_left
	SBI  0x15,0
	LD   R30,Y
	ST   -Y,R30
	RCALL _write_left
	RJMP _0x2B
_0x28:
	LDD  R30,Y+1
	SUBI R30,LOW(64)
	STD  Y+1,R30
	RCALL SUBOPT_0x2
	RCALL _address_right
	SBI  0x15,0
	LD   R30,Y
	ST   -Y,R30
	RCALL _write_right
_0x2B:
	ADIW R28,3
	RET
_glcd_Clear:
	SBIW R28,8
	LDI  R24,8
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x2E*2)
	LDI  R31,HIGH(_0x2E*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	page -> Y+6
;	i -> R16,R17
;	j -> R18,R19
;	index -> R20,R21
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	__GETWRN 16,17,0
_0x30:
	__CPWRN 16,17,8
	BRGE _0x31
	__GETWRN 18,19,0
_0x33:
	__CPWRN 18,19,128
	BRGE _0x34
	ST   -Y,R16
	ST   -Y,R18
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _glcd_WriteByte
	__ADDWRN 18,19,1
	RJMP _0x33
_0x34:
	__ADDWRN 16,17,1
	RJMP _0x30
_0x31:
	CALL __LOADLOCR6
	ADIW R28,14
	RET
_glcd_DrawF:
	CALL __SAVELOCR4
;	*Pat -> Y+4
;	i -> R17
;	j -> R16
;	k -> R18,R19
	LDI  R18,0
	LDI  R19,0
	LDI  R17,LOW(0)
_0x36:
	CPI  R17,8
	BRSH _0x37
	LDI  R16,LOW(0)
_0x39:
	CPI  R16,128
	BRSH _0x3A
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL SUBOPT_0x3
	SUBI R16,-1
	RJMP _0x39
_0x3A:
	SUBI R17,-1
	RJMP _0x36
_0x37:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
;	*Pat -> Y+4
;	i -> R17
;	j -> R16
;	k -> R18,R19
;	*Pat -> Y+8
;	x -> Y+7
;	y -> Y+6
;	h -> Y+5
;	w -> Y+4
;	i -> R17
;	j -> R16
;	k -> R18,R19
_glcd_DrawBmp:
	CALL __SAVELOCR4
;	*Pat -> Y+8
;	x -> Y+7
;	y -> Y+6
;	h -> Y+5
;	w -> Y+4
;	i -> R17
;	j -> R16
;	k -> R18,R19
	LDI  R18,0
	LDI  R19,0
	LDD  R17,Y+7
_0x48:
	LDD  R30,Y+5
	LDD  R26,Y+7
	ADD  R30,R26
	CP   R17,R30
	BRSH _0x49
	LDD  R16,Y+6
_0x4B:
	LDD  R30,Y+4
	LDD  R26,Y+6
	ADD  R30,R26
	CP   R16,R30
	BRSH _0x4C
	LDD  R26,Y+7
	MOV  R30,R17
	SUB  R30,R26
	LDI  R31,0
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	CALL __MULW12U
	MOVW R0,R30
	LDD  R26,Y+6
	MOV  R30,R16
	SUB  R30,R26
	LDI  R31,0
	ADD  R30,R0
	ADC  R31,R1
	MOVW R18,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R18
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RCALL _glcd_WriteByte
	SUBI R16,-1
	RJMP _0x4B
_0x4C:
	SUBI R17,-1
	RJMP _0x48
_0x49:
	CALL __LOADLOCR4
	ADIW R28,10
	RET
_glcd_Putchar:
	ST   -Y,R17
;	x -> Y+3
;	y -> Y+2
;	ch -> Y+1
;	i -> R17
	LDD  R30,Y+1
	SUBI R30,LOW(32)
	STD  Y+1,R30
	LDI  R17,LOW(0)
_0x4E:
	CPI  R17,6
	BRSH _0x4F
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_FontLookup*2)
	SBCI R31,HIGH(-_FontLookup*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	RCALL SUBOPT_0x3
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	STD  Y+2,R30
	SUBI R17,-1
	RJMP _0x4E
_0x4F:
	LDD  R17,Y+0
	RJMP _0x5C
_glcd_Printf:
;	x -> Y+3
;	y -> Y+2
;	*str -> Y+0
_0x50:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x52
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X+
	STD  Y+2,R26
	STD  Y+2+1,R27
	ST   -Y,R30
	RCALL _glcd_Putchar
	LDD  R30,Y+2
	SUBI R30,-LOW(6)
	STD  Y+2,R30
	RJMP _0x50
_0x52:
_0x5C:
	ADIW R28,4
	RET
;      38 
;      39 // Bitmaps
;      40 flash unsigned char  pat1[1024] = {
;      41 255,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      42    1,  1,  1,  1,  1,129,129,129,129,129,  1,  1,  1,  1,  1,  1,
;      43    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      44    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      45    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      46    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      47    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
;      48    1,  1,  1,  1,  1,  1,129,  1,  1,  1,  1,  1,  1,  1,  1,255,
;      49  255,  0,  0,  0,  0,  0,  0,  0,  0,128,192,224,240,120, 56, 28,
;      50   30, 14, 15,  7,  7,131,131,195,195,193,  0,  0,  0,  0,  0,  0,
;      51    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,  0,  0,
;      52    0,  0, 64, 64,192,192, 64,112,112,112, 80, 72, 72,104,112, 64,
;      53   64,112, 96,112, 80, 72, 72,104,112, 64, 72, 72, 72, 40, 25, 56,
;      54   72, 72, 64, 66,114,  0,  0,  0,  0,192,  0,  0, 16,  0,  0, 16,
;      55  224, 64, 64, 64, 48, 72, 88,112, 64, 64, 72, 72,104, 40, 24,104,
;      56   72, 64, 64, 90, 32,  0,127,  0,  0,  0,  0,  0,  0,  0,  0,255,
;      57  255,  0,  0,  0,128,224,248,254,255,111, 35,  1,128,192,240,248,
;      58  252, 60, 30, 15, 15,  7,  7,131,131,131,128,128,128,128,128,  0,
;      59    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  6,
;      60    4,  4,  6,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
;      61    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
;      62    0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  6,  4,  4,  4,  2,
;      63    1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,
;      64    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,255,
;      65  255,  0,  0,252,255,255,255,255,  3,  0,224,254,255,255,  7,  1,
;      66    0,  0,240,252,190,143,135,131,131,129,129,129,129,131,131,135,
;      67  143,158,252,248,192,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
;      68    0,  0, 96,208, 16, 16,  8,  0,128,  0,  0, 32,  0,  0,  0,  0,
;      69  128,128,128,  0,  0,  0,  0,  0,128,  0,  0,  0, 32,128, 32, 32,
;      70  208, 16, 16,  8,  0,248,  0,  0,248,  0,  0,  0,  0,  0,  0,128,
;      71  128,128,  0,  0,  0,  0,  0,  0,  0,  0,128,176,176,128,  0,  0,
;      72    0,  0,  0,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,255,
;      73  255,  0,  0, 63,255,255,255,255,192,  0,  7,127,255,255,224,128,
;      74    0,  0, 15, 63,125,241,225,  1,  1,  1,  1,  1,  1,  1,  1,225,
;      75  241,121, 63, 31,  3,  0,  0,  0,  0,  0,  0,  2,  4,  4,  4,  4,
;      76    4,  4,  4,  5,  3,  4,  4, 20,  7, 20,  4,  4,  7,  0, 32, 32,
;      77   19, 26, 15,  0, 64, 32, 48, 16, 13,  6,  4,  4,  4,  3,  4,  4,
;      78    4,  7,  6,  4,  4,  6,  3,  0,  7,  0,  0,  0,  0, 32, 49, 18,
;      79   10,  7,  0,  0,  0,  0,  4, 26, 16, 16, 17, 18, 26, 15,  0, 96,
;      80   32, 48, 24, 15,  6,  4,  4, 20,  7,  0,  0,  0,  0,  0,  0,255,
;      81  255,  0,  0,  0,  1,  7, 31,127,255,246,196,128,  1,  3, 15, 31,
;      82   63, 60,120,240,240,224,224,192,192,192,  0,  0,  0,  0,  0,  0,
;      83    0,  0,128,  0,  0,  0,  0,128,128,  0,  0,  0,128,  0,  0,128,
;      84    0,  0,  0,  0,128,128,  0,  0,  0,128,  0,  0,128,  0,  0,  0,
;      85    0,128,128,  0,  0,  0,128,  0,  0,  0,  0,  0,  0,128,128,128,
;      86  128,128,128,128,  0,  0,  0,  0,128,128,128,128,128,  0,  0,  0,
;      87    0,  0,  0,128,128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,128,
;      88  128,  0,  0,  0,128,128,128,128,128,128,  0,  0,  0,  0,  0,255,
;      89  255,  0,  0,  0,  0,  0,  0,  0,  0,  1,  3,  7, 15, 30, 28, 56,
;      90  120,112,240,224,224,193,193,195,195,131,  0,  0,  0,  0,  0,  0,
;      91    0,  0,  1, 62,192,224, 30,  1, 15,248,128,124,  7,  0,  0,  3,
;      92   62,192,224, 30,  1, 15,248,128,124,  7,  0,  0,  3,126,128,224,
;      93   30,  0, 15,240,128,126,  3,  0,  0,  0,  0,  0,  0,255,255, 24,
;      94   24, 24, 24, 24,  0,  0,  0,255,129,  0,  0,  0,129,195,  0,  0,
;      95    0,224, 60, 35, 35, 62,224,  0,  0,  0,  0,  0,  0,  0,  0,255,
;      96  255,  0,  0,  0,255, 24, 24, 24, 56,201,135,  0,  0,  0,  0,255,
;      97  255,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,
;      98  128,128,128,128,128,129,129,129,129,129,128,128,128,128,128,128,
;      99  128,128,128,128,131,131,128,128,128,129,131,128,128,128,128,128,
;     100  128,131,131,128,128,128,129,131,128,128,128,128,128,128,131,129,
;     101  128,128,128,129,131,128,128,128,128,131,128,128,128,131,131,131,
;     102  131,131,131,131,128,128,128,128,129,131,131,131,129,128,128,128,
;     103  131,129,128,128,128,128,128,131,128,128,128,131,128,128,128,131,
;     104  131,128,128,128,131,128,128,128,128,128,131,130,128,128,128,255
;     105 };
;     106 
;     107 flash unsigned char  pat2[1024] = {
;     108    0,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     109  254,254,254,254,254,126,126,126,126,126,254,254,254,254,254,254,
;     110  254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     111  254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     112  254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     113  254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     114  254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,
;     115  254,254,254,254,254,254,126,254,254,254,254,254,254,254,254,  0,
;     116    0,255,255,255,255,255,255,255,255,127, 63, 31, 15,135,199,227,
;     117  225,241,240,248,248,124,124, 60, 60, 62,255,255,255,255,255,255,
;     118  255,255,255,255,255,255,255,255,255,255,255,255,255,127,255,255,
;     119  255,255,191,191, 63, 63,191,143,143,143,175,183,183,151,143,191,
;     120  191,143,159,143,175,183,183,151,143,191,183,183,183,215,230,199,
;     121  183,183,191,189,141,255,255,255,255, 63,255,255,239,255,255,239,
;     122   31,191,191,191,207,183,167,143,191,191,183,183,151,215,231,151,
;     123  183,191,191,165,223,255,128,255,255,255,255,255,255,255,255,  0,
;     124    0,255,255,255,127, 31,  7,  1,  0,144,220,254,127, 63, 15,  7,
;     125    3,195,225,240,240,248,248,124,124,124,127,127,127,127,127,255,
;     126  255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,249,
;     127  251,251,249,253,253,254,255,255,255,255,255,255,255,255,255,255,
;     128  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
;     129  255,255,255,255,255,255,255,255,255,254,253,249,251,251,251,253,
;     130  254,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,
;     131  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,  0,
;     132    0,255,255,  3,  0,  0,  0,  0,252,255, 31,  1,  0,  0,248,254,
;     133  255,255, 15,  3, 65,112,120,124,124,126,126,126,126,124,124,120,
;     134  112, 97,  3,  7, 63,255,255,255,255,255,255,255,255,255,255,255,
;     135  255,255,159, 47,239,239,247,255,127,255,255,223,255,255,255,255,
;     136  127,127,127,255,255,255,255,255,127,255,255,255,223,127,223,223,
;     137   47,239,239,247,255,  7,255,255,  7,255,255,255,255,255,255,127,
;     138  127,127,255,255,255,255,255,255,255,255,127, 79, 79,127,255,255,
;     139  255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,  0,
;     140    0,255,255,192,  0,  0,  0,  0, 63,255,248,128,  0,  0, 31,127,
;     141  255,255,240,192,130, 14, 30,254,254,254,254,254,254,254,254, 30,
;     142   14,134,192,224,252,255,255,255,255,255,255,253,251,251,251,251,
;     143  251,251,251,250,252,251,251,235,248,235,251,251,248,255,223,223,
;     144  236,229,240,255,191,223,207,239,242,249,251,251,251,252,251,251,
;     145  251,248,249,251,251,249,252,255,248,255,255,255,255,223,206,237,
;     146  245,248,255,255,255,255,251,229,239,239,238,237,229,240,255,159,
;     147  223,207,231,240,249,251,251,235,248,255,255,255,255,255,255,  0,
;     148    0,255,255,255,254,248,224,128,  0,  9, 59,127,254,252,240,224,
;     149  192,195,135, 15, 15, 31, 31, 63, 63, 63,255,255,255,255,255,255,
;     150  255,255,127,255,255,255,255,127,127,255,255,255,127,255,255,127,
;     151  255,255,255,255,127,127,255,255,255,127,255,255,127,255,255,255,
;     152  255,127,127,255,255,255,127,255,255,255,255,255,255,127,127,127,
;     153  127,127,127,127,255,255,255,255,127,127,127,127,127,255,255,255,
;     154  255,255,255,127,127,255,255,255,255,255,255,255,255,255,255,127,
;     155  127,255,255,255,127,127,127,127,127,127,255,255,255,255,255,  0,
;     156    0,255,255,255,255,255,255,255,255,254,252,248,240,225,227,199,
;     157  135,143, 15, 31, 31, 62, 62, 60, 60,124,255,255,255,255,255,255,
;     158  255,255,254,193, 63, 31,225,254,240,  7,127,131,248,255,255,252,
;     159  193, 63, 31,225,254,240,  7,127,131,248,255,255,252,129,127, 31,
;     160  225,255,240, 15,127,129,252,255,255,255,255,255,255,  0,  0,231,
;     161  231,231,231,231,255,255,255,  0,126,255,255,255,126, 60,255,255,
;     162  255, 31,195,220,220,193, 31,255,255,255,255,255,255,255,255,  0,
;     163    0,255,255,255,  0,231,231,231,199, 54,120,255,255,255,255,  0,
;     164    0,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,
;     165  127,127,127,127,127,126,126,126,126,126,127,127,127,127,127,127,
;     166  127,127,127,127,124,124,127,127,127,126,124,127,127,127,127,127,
;     167  127,124,124,127,127,127,126,124,127,127,127,127,127,127,124,126,
;     168  127,127,127,126,124,127,127,127,127,124,127,127,127,124,124,124,
;     169  124,124,124,124,127,127,127,127,126,124,124,124,126,127,127,127,
;     170  124,126,127,127,127,127,127,124,127,127,127,124,127,127,127,124,
;     171  124,127,127,127,124,127,127,127,127,127,124,125,127,127,127,  0
;     172 };
;     173 
;     174 unsigned char E[72]={

	.DSEG
_E:
;     175 		0x00, 0x01, 0x01, 0x01,
;     176 		0x01, 0xFF, 0xFF, 0xFF,
;     177 		0xFF, 0x01, 0x01, 0x01,
;     178 		0x01, 0x01, 0x01, 0x01,
;     179 		0x01, 0x01, 0x01, 0x03,
;     180 		0x07, 0x1F, 0x00, 0x00,
;     181 
;     182 		0x00, 0x00, 0x00, 0x00,
;     183 		0x00, 0xFF, 0xFF, 0xFF,
;     184 		0xFF, 0x08, 0x08, 0x08,
;     185 		0x08, 0x08, 0x08, 0x08,
;     186 		0x08, 0x1C, 0x3E, 0xFF,
;     187 		0x00, 0x00, 0x00, 0x00,
;     188 
;     189 		0x00, 0x80, 0x80, 0x80,
;     190 		0xC0, 0xFF, 0xFF, 0xFF,
;     191 		0xFF, 0x80, 0x80, 0x80,
;     192 		0x80, 0x80, 0x80, 0x80,
;     193 		0x80, 0x80, 0xC0, 0xC0,
;     194 		0xE0, 0xF0, 0x38, 0x0C
;     195 };
	.BYTE 0x48
;     196 
;     197 void init();
;     198 
;     199 void main(void)
;     200 {

	.CSEG
_main:
;     201 	unsigned char i;
;     202 	unsigned char str[] = "www.eca.ir";
;     203 	// Micro initialize
;     204         init();
	SBIW R28,11
	LDI  R24,11
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x54*2)
	LDI  R31,HIGH(_0x54*2)
	CALL __INITLOCB
;	i -> R17
;	str -> Y+0
	RCALL _init
;     205         // Graphic Lcd initialize
;     206         glcd_Init();
	RCALL _glcd_Init
;     207        	//  Draw bitmap to lcd
;     208        	for(i =0; i<2;i++)
	LDI  R17,LOW(0)
_0x56:
	CPI  R17,2
	BRSH _0x57
;     209        	{
;     210        		glcd_DrawF(pat1);
	LDI  R30,LOW(_pat1*2)
	LDI  R31,HIGH(_pat1*2)
	RCALL SUBOPT_0x4
;     211       		delay_ms(500);
;     212        		glcd_DrawF(pat2);
	LDI  R30,LOW(_pat2*2)
	LDI  R31,HIGH(_pat2*2)
	RCALL SUBOPT_0x4
;     213        		delay_ms(500);
;     214        	}
	SUBI R17,-1
	RJMP _0x56
_0x57:
;     215 	//
;     216         // Print string "www.eca.ir" in middle of page
;     217       	glcd_Clear();
	RCALL _glcd_Clear
;     218        	glcd_Printf(1,40,str);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _glcd_Printf
;     219        	glcd_DrawBmp(E,4,50,3,24);
	LDI  R30,LOW(_E)
	LDI  R31,HIGH(_E)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	RCALL _glcd_DrawBmp
;     220         while (1)
_0x58:
;     221       	{};
	RJMP _0x58
;     222 }
_0x5B:
	RJMP _0x5B
;     223 
;     224 void init()
;     225 {
_init:
;     226   // Declare your local variables here
;     227 
;     228 // Input/Output Ports initialization
;     229 // Port A initialization
;     230 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     231 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     232 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     233 DDRA=0x00;
	OUT  0x1A,R30
;     234 
;     235 // Port B initialization
;     236 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     237 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     238 PORTB=0x00;
	OUT  0x18,R30
;     239 DDRB=0x00;
	OUT  0x17,R30
;     240 
;     241 // Port C initialization
;     242 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     243 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     244 PORTC=0x00;
	OUT  0x15,R30
;     245 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     246 
;     247 // Port D initialization
;     248 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     249 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     250 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     251 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     252 
;     253 // Timer/Counter 0 initialization
;     254 // Clock source: System Clock
;     255 // Clock value: Timer 0 Stopped
;     256 // Mode: Normal top=FFh
;     257 // OC0 output: Disconnected
;     258 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     259 TCNT0=0x00;
	OUT  0x32,R30
;     260 OCR0=0x00;
	OUT  0x3C,R30
;     261 
;     262 // Timer/Counter 1 initialization
;     263 // Clock source: System Clock
;     264 // Clock value: Timer 1 Stopped
;     265 // Mode: Normal top=FFFFh
;     266 // OC1A output: Discon.
;     267 // OC1B output: Discon.
;     268 // Noise Canceler: Off
;     269 // Input Capture on Falling Edge
;     270 // Timer 1 Overflow Interrupt: Off
;     271 // Input Capture Interrupt: Off
;     272 // Compare A Match Interrupt: Off
;     273 // Compare B Match Interrupt: Off
;     274 TCCR1A=0x00;
	OUT  0x2F,R30
;     275 TCCR1B=0x00;
	OUT  0x2E,R30
;     276 TCNT1H=0x00;
	OUT  0x2D,R30
;     277 TCNT1L=0x00;
	OUT  0x2C,R30
;     278 ICR1H=0x00;
	OUT  0x27,R30
;     279 ICR1L=0x00;
	OUT  0x26,R30
;     280 OCR1AH=0x00;
	OUT  0x2B,R30
;     281 OCR1AL=0x00;
	OUT  0x2A,R30
;     282 OCR1BH=0x00;
	OUT  0x29,R30
;     283 OCR1BL=0x00;
	OUT  0x28,R30
;     284 
;     285 // Timer/Counter 2 initialization
;     286 // Clock source: System Clock
;     287 // Clock value: Timer 2 Stopped
;     288 // Mode: Normal top=FFh
;     289 // OC2 output: Disconnected
;     290 ASSR=0x00;
	OUT  0x22,R30
;     291 TCCR2=0x00;
	OUT  0x25,R30
;     292 TCNT2=0x00;
	OUT  0x24,R30
;     293 OCR2=0x00;
	OUT  0x23,R30
;     294 
;     295 // External Interrupt(s) initialization
;     296 // INT0: Off
;     297 // INT1: Off
;     298 // INT2: Off
;     299 MCUCR=0x00;
	OUT  0x35,R30
;     300 MCUCSR=0x00;
	OUT  0x34,R30
;     301 
;     302 // Timer(s)/Counter(s) Interrupt(s) initialization
;     303 TIMSK=0x00;
	OUT  0x39,R30
;     304 
;     305 // Analog Comparator initialization
;     306 // Analog Comparator: Off
;     307 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     308 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     309 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     310 
;     311 }
	RET


;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	__DELAY_USB 3
	LD   R30,Y
	OUT  0x12,R30
	SBI  0x15,2
	__DELAY_USB 3
	CBI  0x15,2
	CBI  0x15,3
	CBI  0x15,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,2
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2:
	LDD  R30,Y+2
	ORI  R30,LOW(0xB8)
	ANDI R30,0xBF
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+3
	ORI  R30,0x40
	ANDI R30,0x7F
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ST   -Y,R30
	RJMP _glcd_WriteByte

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _glcd_DrawF
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
